diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index c3617418e..5e85d1edc 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -37,6 +37,7 @@ dependencies {
 
     // <core dependencies>
     implementation(libs.jetbrains.annotations)?.let { include(it) }
+    implementation(libs.fastutil)?.let { include(it) }
     implementation(libs.gson)?.let { include(it) }
     implementation(libs.brigadier)?.let { include(it) }
     implementation(libs.bundles.log4j)?.let { include(it) }
diff --git a/game/client/src/main/java/net/minecraft/client/GLAllocation.java b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
index a7ba78a94..167988eb1 100644
--- a/game/client/src/main/java/net/minecraft/client/GLAllocation.java
+++ b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
@@ -3,12 +3,15 @@ package net.minecraft.client;
 import java.nio.*;
 import java.util.ArrayList;
 import java.util.List;
+
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import org.lwjgl.opengl.GL11;
 
 public class GLAllocation {
 
-	public static List<Integer> displayLists = new ArrayList<>();
-	public static List<Integer> textureNames = new ArrayList<>();
+	public static IntList displayLists = new IntArrayList();
+	public static IntList textureNames = new IntArrayList();
 
 	public GLAllocation() {}
 
@@ -22,7 +25,7 @@ public class GLAllocation {
 	public static synchronized void generateTextureNames(IntBuffer intbuffer) {
 		GL11.glGenTextures(intbuffer);
 		for (int i = intbuffer.position(); i < intbuffer.limit(); i++) {
-			textureNames.add(Integer.valueOf(intbuffer.get(i)));
+			textureNames.add(intbuffer.get(i));
 		}
 
 	}
@@ -36,8 +39,8 @@ public class GLAllocation {
 	public static synchronized void deleteTexture(int tex) {
 		GL11.glDeleteTextures(tex);
 		for (int i = 0; i < textureNames.size(); i++) {
-			if (textureNames.get(i) == tex) {
-				textureNames.remove(i);
+			if (textureNames.getInt(i) == tex) {
+				textureNames.removeInt(i);
 				return;
 			}
 		}
@@ -47,14 +50,14 @@ public class GLAllocation {
 	{
 		int displayListIndex = displayLists.indexOf(displayList);
 		if (displayListIndex < 0) return;
-		GL11.glDeleteLists(displayLists.get(displayListIndex), displayLists.get(displayListIndex + 1));
-		displayLists.remove(displayListIndex);
-		displayLists.remove(displayListIndex);
+		GL11.glDeleteLists(displayLists.getInt(displayListIndex), displayLists.getInt(displayListIndex + 1));
+		displayLists.removeInt(displayListIndex);
+		displayLists.removeInt(displayListIndex);
 	}
 
 	public static synchronized void deleteTexturesAndDisplayLists() {
 		for (int i = 0; i < displayLists.size(); i += 2) {
-			GL11.glDeleteLists(displayLists.get(i), displayLists.get(i + 1));
+			GL11.glDeleteLists(displayLists.getInt(i), displayLists.getInt(i + 1));
 		}
 
 		IntBuffer intbuffer = createDirectIntBuffer(textureNames.size());
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index b48af2805..42c494a26 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -14,6 +14,9 @@ import java.util.*;
 
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2LongLinkedOpenHashMap;
+import it.unimi.dsi.fastutil.objects.Object2LongMap;
 import net.minecraft.client.console.LogMessageReceiver;
 import net.minecraft.client.console.shell.BindManager;
 import net.minecraft.client.entity.ClientSkinVariantList;
@@ -375,7 +378,7 @@ public class Minecraft
 			running = false;
 
 			LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
-			
+
 			gameWindow.displayCrashReport(throwable, 1);
 			hasCrashed = true;
 			shutdownMinecraftApplet();
@@ -387,7 +390,7 @@ public class Minecraft
 			running = false;
 
             LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
-			
+
 			gameWindow.displayCrashReport(throwable, 1);
 			hasCrashed = true;
 			shutdownMinecraftApplet();
@@ -398,7 +401,7 @@ public class Minecraft
 			running = false;
 
             LOGGER.error("An exception has occurred while trying to start the game!", throwable.exception);
-			
+
 			gameWindow.displayCrashReport(throwable, 2);
 			shutdownMinecraftApplet();
 			return;
@@ -487,7 +490,7 @@ public class Minecraft
         LOGGER.info("Java Version: {}", System.getProperty("java.version"));
 
 		printWrongJavaVersionInfo();
-		
+
 		gameWindow.init(this, overrideWidth != null ? overrideWidth : gameSettings.windowWidth.value, overrideHeight != null ? overrideHeight : gameSettings.windowHeight.value);
 
         final @Nullable String vendorString = GL11.glGetString(GL_VENDOR);
@@ -588,7 +591,7 @@ public class Minecraft
         loadScreen();	// Update loading screen so it doesn't say no response
         
         Colorizers.init(this);
-        
+
         textureManager.refreshTextures(new ArrayList<>());
 
         OptionsPages.init();
@@ -1087,7 +1090,7 @@ public class Minecraft
                     
                     Debug.change("render"); // 2
                     Debug.push("post"); // 3
-                    
+
                     renderer.beginRenderGame(timer.partialTicks);
                     glEnable(GL_ALPHA_TEST);
 
@@ -1563,9 +1566,9 @@ public class Minecraft
                         	step += MathHelper.clamp(scrollDelta, -1, 1);
                         	float newSpeed = step / steps;
                         	newSpeed = MathHelper.clamp(newSpeed, 0.0f, 5.0f);
-                        	
+
                         	gameSettings.flightSpeed.value = newSpeed;
-                        	
+
                         	thePlayer.setFlySpeed(newSpeed);
                         	hudIngame.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.flightSpeed);
                         }
@@ -2349,7 +2352,7 @@ public class Minecraft
     {
     	mainMenuBackground.deleteTextures();
     	gameSettings.showCollisionBoxes.value = false;
-    	
+
         fullbright = false;
         statsCounter.fetchStats();
         statsCounter.saveStats();
@@ -2866,8 +2869,8 @@ public class Minecraft
     }
 
     private static class TimeKeeper {
-        private final @NotNull Map<@NotNull String, @NotNull Long> startTimes = new LinkedHashMap<>();
-        private final @NotNull Map<@NotNull String, @NotNull Long> endTimes = new LinkedHashMap<>();
+        private final @NotNull Object2LongMap<@NotNull String> startTimes = new Object2LongLinkedOpenHashMap<>();
+        private final @NotNull Object2LongMap<@NotNull String> endTimes = new Object2LongLinkedOpenHashMap<>();
 
         public void start(final @NotNull String key) {
             if (this.startTimes.containsKey(key)) LOGGER.error("Start key {} already assigned", key);
@@ -2887,9 +2890,8 @@ public class Minecraft
                     LOGGER.error("Perf key {} not ended!", s);
                     continue;
                 }
-                final Long start = this.startTimes.get(s);
-                final Long end = this.endTimes.get(s);
-                if (start == null || end == null) continue;
+                final long start = this.startTimes.getLong(s);
+                final long end = this.endTimes.getLong(s);
                 builder.append("\n\t").append(s).append(": ").append((end - start)/1000d).append("s");
             }
             return builder.toString();
diff --git a/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java b/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java
index aed2a30c3..7b83fa1e8 100644
--- a/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java
+++ b/game/client/src/main/java/net/minecraft/client/console/shell/BindManager.java
@@ -1,5 +1,8 @@
 package net.minecraft.client.console.shell;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.ints.IntCollection;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -13,9 +16,9 @@ public final class BindManager {
         return INSTANCE;
     }
 
-    private @NotNull Map<@NotNull Integer, @NotNull Runnable> keyToRunnableMap = new HashMap<>();
+    private @NotNull Int2ObjectMap<@NotNull Runnable> keyToRunnableMap = new Int2ObjectOpenHashMap<>();
 
-    public @NotNull Collection<@NotNull Integer> getKeys() {
+    public @NotNull IntCollection getKeys() {
         return this.keyToRunnableMap.keySet();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index 086c36f1f..a3720b658 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -15,6 +15,8 @@ import com.google.gson.JsonObject;
 import com.google.gson.JsonParseException;
 import com.google.gson.JsonParser;
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.util.helper.MathHelper;
@@ -162,10 +164,10 @@ public class ClientSkinVariantList extends SkinVariantList {
 			}
 
 
-			final Map<String, Integer> counts = new HashMap<>();
+			final Object2IntMap<String> counts = new Object2IntOpenHashMap<>();
 			for (final VariantEntry e : this.variantEntries) {
 				counts.putIfAbsent(e.textureKey, 0);
-				counts.put(e.textureKey, counts.get(e.textureKey) + 1);
+				counts.put(e.textureKey, counts.getInt(e.textureKey) + 1);
 			}
 		}
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
index 58517d278..eb120d727 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenTextureViewer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui;
 
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.IListenerElement;
@@ -107,7 +108,7 @@ public class ScreenTextureViewer extends Screen {
     }
 
     protected void cycleTexture(int offset) {
-        List<Integer> textureList = GLAllocation.textureNames;
+        IntList textureList = GLAllocation.textureNames;
         texIndex += offset;
         if (texIndex < 0) {
             texIndex += textureList.size();
@@ -120,11 +121,11 @@ public class ScreenTextureViewer extends Screen {
 
         drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.texture_viewer.label.title"), width/2, 5, 0xFFFFFF);
 
-        List<Integer> textureList = GLAllocation.textureNames;
+        IntList textureList = GLAllocation.textureNames;
         int id = texIndex % textureList.size();
-        GL11.glBindTexture(GL_TEXTURE_2D, textureList.get(id));
+        GL11.glBindTexture(GL_TEXTURE_2D, textureList.getInt(id));
 
-        Texture t = mc.textureManager.idToTextureMap.get(textureList.get(id));
+        Texture t = mc.textureManager.idToTextureMap.get(textureList.getInt(id));
 
 
         GL11.glEnable(GL_BLEND);
@@ -157,7 +158,7 @@ public class ScreenTextureViewer extends Screen {
             tessellator.draw();
         }
 
-        GL11.glBindTexture(GL_TEXTURE_2D, textureList.get(id));
+        GL11.glBindTexture(GL_TEXTURE_2D, textureList.getInt(id));
         tessellator.startDrawingQuads();
         if (flip) {
             tessellator.addVertexWithUV(x + 0,          y + imgHeight,  zLevel, 0, 0);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
index 89cc167c3..5c5b54947 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/GuiElementChatSuggestions.java
@@ -40,6 +40,7 @@ import java.util.List;
 import java.util.Locale;
 import java.util.Map;
 import java.util.Optional;
+import java.util.OptionalInt;
 import java.util.concurrent.CompletableFuture;
 
 @SuppressWarnings({"OptionalGetWithoutIsPresent", "unused"})
@@ -161,7 +162,7 @@ public class GuiElementChatSuggestions extends Gui {
             String suggestionText = this.suggestions.get(i + this.scroll).getText();
             int suggestionHeight = 12 * (-i + Math.min(this.suggestions.size(), MAX_SUGGESTIONS) - 2) + 25;
             String colorCode;
-            if (i + this.scroll == this.commandIndex || (this.isHoveringOverSuggestions(mouseX, mouseY) && i + this.scroll == this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get())) {
+            if (i + this.scroll == this.commandIndex || (this.isHoveringOverSuggestions(mouseX, mouseY) && i + this.scroll == this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).getAsInt())) {
                 colorCode = TextFormatting.YELLOW.toString();
             } else {
                 colorCode = TextFormatting.LIGHT_GRAY.toString();
@@ -172,8 +173,8 @@ public class GuiElementChatSuggestions extends Gui {
             fontRenderer.render(Tessellator.instance, colorCode + suggestionText, textX, minY + suggestionBoxHeight - suggestionHeight + 3).setShadow().setColor(0xE0E0E0).call();
         }
 
-        if (this.isHoveringOverSuggestions(mouseX, mouseY) && this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get()).getTooltip() != null) {
-            this.tooltip.render(this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get()).getTooltip().getString(), mouseX, mouseY, 0, 0);
+        if (this.isHoveringOverSuggestions(mouseX, mouseY) && this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).getAsInt()).getTooltip() != null) {
+            this.tooltip.render(this.suggestions.get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).getAsInt()).getTooltip().getString(), mouseX, mouseY, 0, 0);
         }
     }
 
@@ -208,7 +209,7 @@ public class GuiElementChatSuggestions extends Gui {
 
         if (key == Keyboard.KEY_TAB) {
             if (this.commandIndex == -1 && this.isHoveringOverSuggestions(mouseX, mouseY)) {
-                this.cycleToSuggestion(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get());
+                this.cycleToSuggestion(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).getAsInt());
             } else if (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT)) {
                 this.cycleThroughSuggestions(-1);
             } else {
@@ -331,7 +332,7 @@ public class GuiElementChatSuggestions extends Gui {
 
     public void mouseClicked(int x, int y, int button) {
         if (isHoveringOverSuggestions(x, y) && button == 0) {
-            this.cycleToSuggestion(this.getIndexOfSuggestionBeingHoveredOver(x, y).get());
+            this.cycleToSuggestion(this.getIndexOfSuggestionBeingHoveredOver(x, y).getAsInt());
         }
     }
 
@@ -339,8 +340,8 @@ public class GuiElementChatSuggestions extends Gui {
         return this.getIndexOfSuggestionBeingHoveredOver(cursorX, cursorY).isPresent();
     }
 
-    public Optional<Integer> getIndexOfSuggestionBeingHoveredOver(int cursorX, int cursorY) {
-        if (this.suggestions.isEmpty() || this.hidden) return Optional.empty();
+    public OptionalInt getIndexOfSuggestionBeingHoveredOver(int cursorX, int cursorY) {
+        if (this.suggestions.isEmpty() || this.hidden) return OptionalInt.empty();
 
         int minX = this.xSupplier.get(this.textField, this, this.mc, SUGGESTIONS_FOLLOW_PARAMETERS);
 
@@ -363,10 +364,10 @@ public class GuiElementChatSuggestions extends Gui {
             int suggestionMaxY = suggestionMinY + 12;
 
             if (cursorX >= minX && cursorX < maxX && cursorY >= suggestionMinY && cursorY < suggestionMaxY) {
-                return Optional.of(i + this.scroll);
+                return OptionalInt.of(i + this.scroll);
             }
         }
-        return Optional.empty();
+        return OptionalInt.empty();
     }
 
     private void resetAllManagerVariables() {
@@ -522,7 +523,7 @@ public class GuiElementChatSuggestions extends Gui {
         if (this.shouldDrawSuggestionPreview()) {
             Suggestion suggestionToRender = null;
             if (this.isHoveringOverSuggestions(mouseX, mouseY)) {
-                suggestionToRender = this.getSuggestions().get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).get());
+                suggestionToRender = this.getSuggestions().get(this.getIndexOfSuggestionBeingHoveredOver(mouseX, mouseY).getAsInt());
             } else if (!this.getSuggestions().isEmpty()) {
                 suggestionToRender = this.getSuggestions().get(0);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 135f6ff11..7a1aba857 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -5,6 +5,8 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.ArrayList;
 import java.util.List;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.GuiElement;
 import net.minecraft.client.gui.ListLayout;
@@ -37,7 +39,7 @@ public class ScreenInventory extends ScreenContainerAbstract
     protected int armourValuesFloat = 130;
     protected int armourButtonFloatX = 20;
 	protected ListLayout overlayButtonsLayout = new ListLayout(this).setAlign(0.5, 0.5).setVertical(false).setElementSize(11, 11).setOffset(-(xSize / 2), -(ySize / 2) - 10).setMargin(1);
-	private final List<Integer> uvs = new ArrayList<>();
+	private final IntList uvs = new IntArrayList();
 	
 	private DamageType hoveredDamageType;
 
@@ -171,7 +173,7 @@ public class ScreenInventory extends ScreenContainerAbstract
         
         for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
         	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
-        	drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * uvs.get(i), 9, 9);
+        	drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * uvs.getInt(i), 9, 9);
         	boolean val = true;
         	if(button.option instanceof OptionBoolean) val = (Boolean) button.option.value;
         	if(!val) drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 194, 0, 9, 9);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/drawing/DrawableEditor.java b/game/client/src/main/java/net/minecraft/client/gui/drawing/DrawableEditor.java
index f6370c2c3..5273464f8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/drawing/DrawableEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/drawing/DrawableEditor.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.drawing;
 
+import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.core.util.collection.Pair;
 
 import java.util.Stack;
@@ -230,21 +231,22 @@ public final class DrawableEditor<T>
 
     public void floodFill(int x, int y, T value)
     {
-        Stack<Pair<Integer, Integer>> floodFillStack = new Stack<>();
+        Stack<IntIntPair> floodFillStack = new Stack<>();
         T floodColor = surface.getPixelValue(x, y);
         if (floodColor == value) return;
 
-        floodFillStack.push(Pair.of(x, y));
+        floodFillStack.push(IntIntPair.of(x, y));
         while (!floodFillStack.isEmpty())
         {
-            Pair<Integer, Integer> item = floodFillStack.pop();
-            if (surface.getPixelValue(item.getLeft(), item.getRight()) == floodColor)
+
+            IntIntPair item = floodFillStack.pop();
+            if (surface.getPixelValue(item.leftInt(), item.rightInt()) == floodColor)
             {
-                drawPixel(item.getLeft(), item.getRight(), value);
-                if (item.getLeft() - 1 >= 0) floodFillStack.push(Pair.of(item.getLeft() - 1, item.getRight()));
-                if (item.getLeft() + 1 < surface.getWidth()) floodFillStack.push(Pair.of(item.getLeft() + 1, item.getRight()));
-                if (item.getRight() - 1 >= 0) floodFillStack.push(Pair.of(item.getLeft(), item.getRight() - 1));
-                if (item.getRight() + 1 < surface.getHeight()) floodFillStack.push(Pair.of(item.getLeft(), item.getRight() + 1));
+                drawPixel(item.leftInt(), item.rightInt(), value);
+                if (item.leftInt() - 1 >= 0) floodFillStack.push(IntIntPair.of(item.leftInt() - 1, item.rightInt()));
+                if (item.leftInt() + 1 < surface.getWidth()) floodFillStack.push(IntIntPair.of(item.leftInt() + 1, item.rightInt()));
+                if (item.rightInt() - 1 >= 0) floodFillStack.push(IntIntPair.of(item.leftInt(), item.rightInt() - 1));
+                if (item.rightInt() + 1 < surface.getHeight()) floodFillStack.push(IntIntPair.of(item.leftInt(), item.rightInt() + 1));
             }
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
index 68aa577a0..580d764b6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/PageNavigationStack.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui.guidebook;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.ints.IntStack;
 import org.slf4j.Logger;
 
 import java.util.Stack;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
index 309b28ca1..9e547dbc7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngameDoom.java
@@ -1,5 +1,7 @@
 package net.minecraft.client.gui.hud;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -159,7 +161,7 @@ public class HudIngameDoom
         GL11.glColor4f(1f, 1f, 1f, 1f);
         mc.textureManager.loadTexture("/assets/minecraft/textures/gui/hud/doom.png").bind();
 
-        List<Integer> parts = new ArrayList<>();
+        IntList parts = new IntArrayList();
 
         int prev = 0;
         int mult = 1;
@@ -172,8 +174,8 @@ public class HudIngameDoom
             mult *= 10;
         }
 
-        for (int digit : parts)
-        {
+        for (int j = 0; j < parts.size(); j++) {
+            int digit = parts.getInt(j);
             int width = NUMBER_WIDTHS[digit];
             int u = NUMBER_US[digit];
             int v = 209;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
index eb93e8ac1..2dd4b7466 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.popup;
 
+import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.Pair;
@@ -20,7 +21,7 @@ public class PopupBuilder
     private final List<PopupComponent> components = new ArrayList<>();
     private final Map<PopupComponent, String> componentKeyMap = new HashMap<>();
     private final List<PopupCloseListener> onCloseListeners = new ArrayList<>();
-    private Pair<Integer,Integer> backgroundColor = null;
+    private IntIntPair backgroundColor = null;
 
     public PopupBuilder(Screen parent, int width)
     {
@@ -172,7 +173,7 @@ public class PopupBuilder
     }
 
     public PopupBuilder withBackgroundColor(int color, int color2){
-        this.backgroundColor = Pair.of(color,color2);
+        this.backgroundColor = IntIntPair.of(color,color2);
         return this;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index dd77fcaec..29744e003 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.popup;
 
+import it.unimi.dsi.fastutil.ints.IntIntPair;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.collection.Pair;
@@ -27,7 +28,7 @@ public final class PopupScreen
     private final Map<PopupComponent, String> componentKeyMap;
     private final List<PopupCloseListener> onCloseListeners;
 
-    private final Pair<Integer,Integer> backgroundColor;
+    private final IntIntPair backgroundColor;
 
     private int statusCode = -1;
 
@@ -41,7 +42,7 @@ public final class PopupScreen
             List<PopupComponent> components,
             Map<PopupComponent, String> componentKeyMap,
             List<PopupCloseListener> onCloseListeners,
-            Pair<Integer,Integer> backgroundColor
+            IntIntPair backgroundColor
     )
     {
         this.parent = parent;
@@ -195,7 +196,7 @@ public final class PopupScreen
             int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
             drawGradientRect(0, 0, width, height, color, color);
         } else {
-            drawGradientRect(0, 0, width, height, backgroundColor.getLeft(), backgroundColor.getRight());
+            drawGradientRect(0, 0, width, height, backgroundColor.leftInt(), backgroundColor.rightInt());
         }
 
 
diff --git a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java
index bb94d9005..998afb471 100644
--- a/game/client/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java
+++ b/game/client/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java
@@ -1,13 +1,14 @@
 package net.minecraft.client.input.controller;
 
+import it.unimi.dsi.fastutil.ints.Int2ObjectArrayMap;
+import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
+
 import java.io.BufferedReader;
 import java.io.InputStream;
 import java.io.InputStreamReader;
-import java.util.HashMap;
-import java.util.Map;
 
 public abstract class ControllerTypeDatabase {
-    private static Map<Integer, ControllerType> controllers = null;
+    private static Int2ObjectMap<ControllerType> controllers = null;
 
     public static ControllerType getControllerType(int vid, int pid) {
         int combined = ((vid & 0xFFFF) << 16) | (pid & 0xFFFF);
@@ -18,7 +19,7 @@ public abstract class ControllerTypeDatabase {
     }
 
     private static void init() {
-        controllers = new HashMap<>();
+        controllers = new Int2ObjectArrayMap<>();
 
         // Read controllers.csv
         try (InputStream stream = ControllerTypeDatabase.class.getResourceAsStream("/controllers.csv")) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/FlagRenderer.java b/game/client/src/main/java/net/minecraft/client/render/FlagRenderer.java
index 999c3cdc7..134b3053b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FlagRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FlagRenderer.java
@@ -1,5 +1,8 @@
 package net.minecraft.client.render;
 
+import it.unimi.dsi.fastutil.ints.IntArrayList;
+import it.unimi.dsi.fastutil.ints.IntList;
+import it.unimi.dsi.fastutil.objects.ObjectList;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.item.Items;
@@ -23,7 +26,7 @@ public class FlagRenderer {
 
     private final TextureManager textureManager;
 
-    private final List<Integer> freeTextures = new ArrayList<>();
+    private final IntList freeTextures = new IntArrayList();
     private final List<FlagTextureEntry> flagTextures = new ArrayList<>();
     private final Map<TileEntityFlag, FlagTextureEntry> cache = new Hashtable<>();
     
@@ -109,7 +112,7 @@ public class FlagRenderer {
             if (freeTextures.isEmpty()) {
                 tex = textureManager.createTexture(CANVAS_WIDTH, CANVAS_HEIGHT);
             } else {
-                tex = freeTextures.remove(0);
+                tex = freeTextures.removeInt(0);
             }
             returnEntry = new FlagTextureEntry(tex, flag.colorHash, flag.activeDyes, flag.flagColors);
             flagTextures.add(returnEntry);
@@ -168,8 +171,6 @@ public class FlagRenderer {
             this.colorHash = colorHash;
             this.activeDyes = activeDyes;
             this.colorData = colorData;
-
-
         }
     }
 }
